package com.jeeplus.modules.sg.managementcenter.materialplan.util;
import com.jeeplus.modules.sg.managementcenter.materialplan.entity.InventoryTable;
import com.jeeplus.modules.sg.managementcenter.materialplan.entity.MaterialPlan;
import com.jeeplus.modules.sg.managementcenter.materialplan.entity.Storage;
import groovy.util.IFileNameFinder;
import org.apache.commons.lang3.StringUtils;
import org.apache.poi.ss.formula.functions.T;
import org.apache.poi.ss.usermodel.Row;

import java.util.ArrayList;
import java.util.List;
import java.util.UUID;

public class MaterialPlanInfo {
    public static final Integer MATER_ONE = 1;
    public static final Integer MATER_TWO = 2;
    public static final Integer MATER_THREE = 3;
    public static final Integer MATER_FOUR = 4;
    public static final String MATER_CODE = "物资唯一码";
    public static final String MATER_CODETWO = "批次编码";
    public static final String MATER_NUMBER = "序号";
    public static final String MATER_FLAG = "入库";
    public static final String MATER_MATERIAL="物料";
    public static final String MATER_YES = "是";
    public static final String MATER_NO = "否";
//    public static final String MATER_STORAGE = "是否入库";
//    public static final String MATER_COUNT = "库存数量";
//    public static final String MATER_DONGCOUNT = "冻结数量";
//    public static final String MATER_ITEMNAME = "供应商名称";
    /**
     * 获取表格数据
     * @param importUtil
     * @return List<ErpAccount> 导入表格数据
     */
    public static List<MaterialPlan> getMaterPlanUtil(ImportUtil importUtil)  {
        String requireCount = "";//需求数量
        String inventoryQuantity ="";//库存数量
        String numberFrozen = "";//冻结数量
        int lastRow = importUtil.getLastDataRowNum();
        List<MaterialPlan> list = new ArrayList<MaterialPlan>();
        MaterialPlan materialPlan = null;
        String uniqueCode="";//费用估算
        for(int i=1; i<lastRow;i++){
            materialPlan = new MaterialPlan();
            Row row = importUtil.getRow(i);
            uniqueCode = (String)importUtil.getCellValue(row,0);
            if (StringUtils.isNotBlank(uniqueCode)){
                materialPlan.setUniqueCode(uniqueCode);
                materialPlan.setRequireCoding((String)importUtil.getCellValue(row,1));
                materialPlan.setDescription((String)importUtil.getCellValue(row,2));
                materialPlan.setExpansionCode((String)importUtil.getCellValue(row,3));
                materialPlan.setExpansionDescription((String)importUtil.getCellValue(row,4));
                materialPlan.setBigDescribe((String)importUtil.getCellValue(row,5));
                materialPlan.setModerateDescribe((String)importUtil.getCellValue(row,6));
                materialPlan.setSmallDescribe((String)importUtil.getCellValue(row,7));
                requireCount =(String)importUtil.getCellValue(row,8);
                if (null!=requireCount&&!requireCount.equals("")){
                    materialPlan.setRequireNumber(new Double((String)importUtil.getCellValue(row,8)));
                }
                materialPlan.setUtil((String)importUtil.getCellValue(row,9));
                materialPlan.setPlanToBatch((String)importUtil.getCellValue(row,10));
//                materialPlan.setFlagStorage((String)importUtil.getCellValue(row,12));
//                inventoryQuantity = (String)importUtil.getCellValue(row,13);
//                if (null!=inventoryQuantity&&!inventoryQuantity.equals("")){
//                    materialPlan.setInventoryQuantity(new Double((String)importUtil.getCellValue(row,13)));
//                }
//                numberFrozen = (String)importUtil.getCellValue(row,14);
//                if (null!=numberFrozen&&!inventoryQuantity.equals("")){
//                    materialPlan.setNumberFrozen(new Double((String)importUtil.getCellValue(row,14)));
//                }
//                materialPlan.setSupplierName((String)importUtil.getCellValue(row,15));
                list.add(materialPlan);
            }
        }
        return list;
    }

    /**
     * 导入基础数据 -  库存 数据 list集合
     * @param importUtil
     * @return
     */
    public static List<InventoryTable> getInventoryTableUtil(ImportUtil importUtil)  {
        int lastRow = importUtil.getLastDataRowNum();
        List<InventoryTable> list = new ArrayList<InventoryTable>();
        InventoryTable inventoryTable = null;
        String uniqueCode="";//费用估算
        for(int i=1; i<lastRow;i++){
            inventoryTable = new InventoryTable();
            Row row = importUtil.getRow(i);
            uniqueCode = (String)importUtil.getCellValue(row,3);
            if (StringUtils.isNotBlank(uniqueCode)){
                inventoryTable.setUniqueCode(uniqueCode);
                inventoryTable.setInventoryQuantity((String)importUtil.getCellValue(row,7));
                inventoryTable.setNumberFrozen((String)importUtil.getCellValue(row,9));
                inventoryTable.setSupplierName((String)importUtil.getCellValue(row,15));
                list.add(inventoryTable);
            }
        }
        return list;
    }

    /**
     * 导入是否入库
     */
    public static List<Storage> getFlagStorage(ImportUtil importUtil)  {
        int lastRow = importUtil.getLastDataRowNum();
        List<Storage> list = new ArrayList<Storage>();
        Storage storage = null;
        String uniqueCode="";//费用估算
        for(int i=1; i<lastRow;i++){
            storage = new Storage();
            Row row = importUtil.getRow(i);
            uniqueCode = (String)importUtil.getCellValue(row,0);
            if (StringUtils.isNotBlank(uniqueCode)){
                storage.setUniqueCode(uniqueCode);
                storage.setFlagStorage((String)importUtil.getCellValue(row,1));
                list.add(storage);
            }
        }
        return list;
    }
    /**
     * 判断excel是哪张表
     * @return
     */
    public static Integer getJudgeExcel(ImportUtil importUtil){
        Row row = importUtil.getRow(0);
        String firstName = (String) importUtil.getCellValue(row,0);
        String basicTwoName = (String) importUtil.getCellValue(row,2);
        String twoName = (String)importUtil.getCellValue(row,1);
        String fourName = (String)importUtil.getCellValue(row,4);
        if (firstName.contains(MATER_CODE)||firstName.contains(MATER_CODETWO)){
           if (basicTwoName.contains(MATER_MATERIAL)){
               return MATER_ONE;
           }
            if (twoName.contains(MATER_FLAG)){
                return MATER_THREE;
            }
        }
        if (firstName.contains(MATER_NUMBER)&&fourName.contains(MATER_MATERIAL)){
            return MATER_TWO;
        }
        return MATER_FOUR;
    }

    /**
     * 判断是否入库符合规范
     * @param importUtil
     * @return
     */
    public static boolean getJudeStorage(ImportUtil importUtil){
        boolean flag = false;
        List<Storage> flagStorage = MaterialPlanInfo.getFlagStorage(importUtil);
        if (null!=flagStorage&&flagStorage.size()>0){
            for (Storage storage:flagStorage){
                if (!storage.getFlagStorage().equals(MATER_YES)&&!storage.getFlagStorage().equals(MATER_NO)){
                    flag = true;
                    break;
                }
            }
        }
        return flag;
    }
    /**
     * 获取库存数据
     * @return
     */
    public static List<MaterialPlan> getUpdateMaterPlan(List<MaterialPlan> materialPlanList,ImportUtil importUtil){
        List<InventoryTable> inventoryTableList = MaterialPlanInfo.getInventoryTableUtil(importUtil);
        for (MaterialPlan materialPlan:materialPlanList){
            for (InventoryTable inventoryTable:inventoryTableList){
                if (materialPlan.getUniqueCode().equals(inventoryTable.getUniqueCode())){
                    materialPlan.setInventoryQuantity(new Double(inventoryTable.getInventoryQuantity()));
                    materialPlan.setNumberFrozen(new Double(inventoryTable.getNumberFrozen()));
                    materialPlan.setSupplierName(inventoryTable.getSupplierName());
                }
            }
        }
        return materialPlanList;
    }

    /**
     * 获取是否入库数据
     * @param materialPlanList
     * @param importUtil
     * @return
     */
    public static List<MaterialPlan> getUpdateMaterPlanStorage(List<MaterialPlan> materialPlanList,ImportUtil importUtil){
        List<Storage> flagStorage = MaterialPlanInfo.getFlagStorage(importUtil);
        for (MaterialPlan materialPlan:materialPlanList){
            for (Storage storage:flagStorage){
                if (materialPlan.getUniqueCode().equals(storage.getUniqueCode())){
                    materialPlan.setFlagStorage(storage.getFlagStorage());
                }
            }
        }
        return materialPlanList;
    }
    /**
     * 生成随机数
     * @return
     */
    public static String getStatus(){
        int machineId = 1;
        int hashCodeV = UUID.randomUUID().toString().hashCode();
        if (hashCodeV<0){
            hashCodeV=-hashCodeV;
        }
        return  (machineId+String.format("%015d",hashCodeV));
    }

}
