/**
 * Copyright &copy; 2015-2020 <a href="http://www.jeeplus.org/">JeePlus</a> All rights reserved.
 */
package com.jeeplus.modules.sg.picking.activiti.service;

import com.jeeplus.core.persistence.Page;
import com.jeeplus.core.service.CrudService;
import com.jeeplus.modules.sg.picking.activiti.entity.*;
import com.jeeplus.modules.sg.picking.activiti.mapper.PickIngMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.access.method.P;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;

/**
 * 模块显示Service
 * @author
 * @version 2019-11-08
 */
@Service
@Transactional(readOnly = true)
public class PickIngService extends CrudService<PickIngMapper, PickIng> {
	@Autowired
	private PickIngMapper pickIngMapper;

	@Override
	public Page<PickIng> findPage(Page<PickIng> page, PickIng entity) {
		Page<PickIng> page1 = super.findPage(page, entity);
		return page1;
	}

	/**
	 * 遍历查询结构 大类 中类 小类
	 * 去除重复，记录大类
	 * 根据大类查询它的中类放入list并记录
	 * */
	public List<PickList> newAllList(PickIng entity,String s) {
		entity.setVersion(s);
		//查询除所有数据
		List<PickIng> allList = pickIngMapper.findAllList(entity);
		//创建返回对象集合
		List<PickList> returnList = new ArrayList<>();

		//循环得到所有大类
		for (PickIng pickIng:allList) {
			boolean flag = false;
			for (PickList list : returnList) {
				if (pickIng.getMdBigClass().equals(list.getName())) {
					flag = true;
					break;
				}
			}
			if (flag==false) {
				//创建返回对象
				PickList pickList = new PickList();
				pickList.setName(pickIng.getMdBigClass());
				returnList.add(pickList);
			}
		}

		//循环所有的大类，与查出的数据做比对，相同的就放入同一个实体类
		for (PickList pList : returnList) {
			List<MdTheClass> mdTheClassList = new ArrayList<>();
			//获得大类
			String name = pList.getName();
			//遍历查询的所有数据，与大类做比对，相同的，将中类记录下来
			for (PickIng pickIng:allList) {
				boolean flag = false;
				//如果查出的数据中和记录下的大类一致，将中类放入大类的
				if (pickIng.getMdBigClass().equals(name)) {
					for (MdTheClass md : mdTheClassList) {
						if (md.getName().equals(pickIng.getMdTheClass())) {
							flag = true;
						}
					}
					if (flag==false) {
						//创建中类对象，包含种类名称及对应的小类集合
						MdTheClass mdTheClass = new MdTheClass();
						mdTheClass.setId(pickIng.getId());
						mdTheClass.setName(pickIng.getMdTheClass());
						mdTheClassList.add(mdTheClass);
					}
				}
			}
			pList.setMdTheClassList(mdTheClassList);
		}

		for (PickList pList : returnList) {
			List<MdTheClass> mdTheClassList = pList.getMdTheClassList();
			for (MdTheClass md : mdTheClassList) {
				//创建
				List<MdSmallClass> mdSmallClassList = new ArrayList<>();
				for (PickIng pc : allList) {
					if (md.getName().equals(pc.getMdTheClass())&&pList.getName().equals(pc.getMdBigClass())) {
						//创建小类对象
						MdSmallClass mdSmallClass = new MdSmallClass();
						mdSmallClass.setName(pc.getMdSmallClass());
						mdSmallClass.setId(pc.getId());
						mdSmallClass.setMdUnit(pc.getMdUnit());
						mdSmallClassList.add(mdSmallClass);
					}
					md.setMdSmallClassList(mdSmallClassList);
				}
			}
		}

		return returnList;
	}


	public List<String> allVersion() {
		return  pickIngMapper.allVersion();
	}

	@Transactional(readOnly = false)
	public void updateSelectNumber(String selectNumber,String procInsId) {
		pickIngMapper.updateSelectNumber(selectNumber, procInsId);
	}

	public String findSelectNumber(String procInsId) {
		return pickIngMapper.findSelectNumber(procInsId);
	}

	public String selectVersion(String procInsId) {
		return pickIngMapper.selectVersion(procInsId);
	}

	public ProjectNumber projectNumber(String procInsId) {
		return pickIngMapper.projectNumber(procInsId);
	}
}